var gGeneralDatasource;
var gGeneralBuilder;
var gContentModified = false;
var gCurrentClass = null;

function Init()
{
  gGeneralDatasource=getProfileStore();
  gGeneralBuilder=createRPathTemplateBuilder(gGeneralDatasource,GENERAL_NS,null);
  rebuildPage(gGeneralBuilder,document.documentElement,null); 

  document.getElementById("classList").selectedIndex = 0;
}

function close()
{
  if (gContentModified){
    gContentModified = false;
    saveFields();
  }
}

function contentModified()
{
  gContentModified = true;
}

function saveFields()
{
  if (gCurrentClass == null) return;

  var field = document.getElementById("name").value;
  if (field) RDFAssertOnce(gGeneralDatasource,gCurrentClass,RDFS_NS + "label",field);
  else RDFUnassert(gGeneralDatasource,gCurrentClass,RDFS_NS + "label");

  var field = document.getElementById("subclass").value;
  if (field) RDFAssertOnce(gGeneralDatasource,gCurrentClass,RDFS_NS + "subClassOf",field);
  else RDFUnassert(gGeneralDatasource,gCurrentClass,RDFS_NS + "subClassOf");

  var field = document.getElementById("defns").value;
  if (field) RDFAssertOnce(gGeneralDatasource,gCurrentClass,GENERAL_NS + "defns",field);
  else RDFUnassert(gGeneralDatasource,gCurrentClass,GENERAL_NS + "defns");

  var field = document.getElementById("labelprop").value;
  if (field) RDFAssertOnce(gGeneralDatasource,gCurrentClass,GENERAL_NS + "labelProp",field);
  else RDFUnassert(gGeneralDatasource,gCurrentClass,GENERAL_NS + "labelProp");
}

function changeSelectedClass(event)
{
  if (gContentModified){
    gContentModified = false;
    saveFields();
  }

  var classPanel = document.getElementById("classPanel");
  var classItem = document.getElementById("classList").selectedItem;
  gCurrentClass = gGeneralBuilder.getContextForNode(classItem);
  gGeneralBuilder.resolve(classPanel,gCurrentClass,true);

//  rebuildPage(gGeneralBuilder,classPanel,gCurrentClass);
}

function getSelectedItem(tree)
{
  var selectedIndex = tree.currentIndex;
  if (selectedIndex >= 0) return tree.contentView.getItemAtIndex(selectedIndex);
  else return null;
}

function showContextMenuForItem(evt)
{
/*
  var item = getSelectedItem(evt.target.parentNode);
  if (item){
    document.getElementById("editmenu_edit").removeAttribute("disabled");
    document.getElementById("editmenu_remove").removeAttribute("disabled");
    document.getElementById("editmenu_moveup").removeAttribute("disabled");
    document.getElementById("editmenu_movedown").removeAttribute("disabled");
  }
  else {
    document.getElementById("editmenu_edit").setAttribute("disabled","true");
    document.getElementById("editmenu_remove").setAttribute("disabled","true");
    document.getElementById("editmenu_moveup").setAttribute("disabled","true");
    document.getElementById("editmenu_movedown").setAttribute("disabled","true");
  }
*/
}

function addSelectedDone(itemObj)
{
  container = RDFGetResource(gGeneralDatasource,itemObj.classNode,GENERAL_NS + itemObj.type);
  if (container){
    container = RDFGetContainer(gGeneralDatasource,container);
  }
  else {
    var resource = RDF.GetAnonymousResource();
    RDFAssert(gGeneralDatasource,itemObj.classNode,GENERAL_NS + itemObj.type,resource);

    var RDFContainerUtils = "@mozilla.org/rdf/container-utils;1";
    RDFContainerUtils = Components.classes[RDFContainerUtils].
                          getService(Components.interfaces.nsIRDFContainerUtils);
    container = RDFContainerUtils.MakeSeq(gGeneralDatasource,resource);
  }
  itemObj.resource = RDF.GetAnonymousResource();
  container.AppendElement(itemObj.resource);

  editSelectedDone(itemObj);
}

function editSelectedDone(itemObj)
{
  var resource = itemObj.resource.QueryInterface(Components.interfaces.nsIRDFResource);

  if (itemObj.label)
    RDFAssertOnce(gGeneralDatasource,resource,RDFS_NS + "label",itemObj.label);
  if (itemObj.variant)
    RDFAssertOnce(gGeneralDatasource,resource,GENERAL_NS + "variant",itemObj.variant);
  if (itemObj.display)
    RDFAssertOnce(gGeneralDatasource,resource,GENERAL_NS + "display",itemObj.display);
  if (itemObj.datasource)
    RDFAssertOnce(gGeneralDatasource,resource,GENERAL_NS + "datasource",itemObj.datasource);
  if (itemObj.supplier)
    RDFAssertOnce(gGeneralDatasource,resource,GENERAL_NS + "supplier",itemObj.supplier);

  if (itemObj.classNode == gCurrentClass)
    rebuildPage(gGeneralBuilder,itemObj.tree,gCurrentClass);
}

function addToSelected(islayout)
{
  if (!gCurrentClass) return;

  var windowuri, type;
  if (islayout){
    windowuri = "editLayoutDialog.xul";
    type = "displays";
  }
  else {
    windowuri = "editSourceDialog.xul";
    type = "datasources";
  }

  var tree = document.getElementById(type);

  window.openDialog(windowuri,"_blank","chrome",
                    addSelectedDone,
                    { type: type, tree: tree, classNode: gCurrentClass });
}

function editSelected(islayout)
{
  var windowuri, type;
  if (islayout){
    windowuri = "editLayoutDialog.xul";
    type = "displays";
  }
  else {
    windowuri = "editSourceDialog.xul";
    type = "datasources";
  }
  var tree = document.getElementById(type);

  var item = getSelectedItem(tree);
  if (item){
    var resource = gGeneralBuilder.getContextForNode(item.firstChild.firstChild);

    window.openDialog(windowuri,"_blank","chrome",editSelectedDone,
      { resource: resource, classNode: gCurrentClass, type: type, tree: tree,
        label: RDFGetLiteral(gGeneralDatasource,resource,RDFS_NS + "label"),
        variant: RDFGetLiteral(gGeneralDatasource,resource,GENERAL_NS + "variant"),
        display: RDFGetLiteral(gGeneralDatasource,resource,GENERAL_NS + "display"),
        datasource: RDFGetLiteral(gGeneralDatasource,resource,GENERAL_NS + "datasource"),
        supplier: RDFGetLiteral(gGeneralDatasource,resource,GENERAL_NS + "supplier"),
      });
  }
}

function removeSelected(islayout)
{
  var type = (islayout) ? "displays" : "datasources";
  var tree = document.getElementById(type);
  var item = getSelectedItem(tree);
  if (item){
    var resource = gGeneralBuilder.getContextForNode(item.firstChild.firstChild);
    RDFUnassertAll(gGeneralDatasource,resource,false);

    container = RDFGetResource(gGeneralDatasource,gCurrentClass,GENERAL_NS + type);
    container = RDFGetContainer(gGeneralDatasource,container);
    container.RemoveElement(resource,true);

    rebuildPage(gGeneralBuilder,tree,gCurrentClass);
  }
}

function moveUpSelected(islayout)
{
  var type = (islayout) ? "displays" : "datasources";
  var tree = document.getElementById(type);
  var item = getSelectedItem(tree);
  if (item){
    var resource = gGeneralBuilder.getContextForNode(item.firstChild.firstChild);

    container = RDFGetResource(gGeneralDatasource,gCurrentClass,GENERAL_NS + type);
    container = RDFGetContainer(gGeneralDatasource,container);

    var index = container.IndexOf(resource);
    if (index > 1){
      container.RemoveElementAt(index,true);
      container.InsertElementAt(resource,index - 1,true);
    }

    rebuildPage(gGeneralBuilder,item.parentNode,gCurrentClass);
  }
}

function moveDownSelected(islayout)
{
  var type = (islayout) ? "displays" : "datasources";
  var tree = document.getElementById(type);
  var item = getSelectedItem(tree);
  if (item){
    var resource = gGeneralBuilder.getContextForNode(item.firstChild.firstChild);

    container = RDFGetResource(gGeneralDatasource,gCurrentClass,GENERAL_NS + type);
    container = RDFGetContainer(gGeneralDatasource,container);

    var index = container.IndexOf(resource);
    var count = container.GetCount();
    if (index < count){
      container.RemoveElementAt(index,true);
      container.InsertElementAt(resource,index + 1,true);
    }

    rebuildPage(gGeneralBuilder,item.parentNode,gCurrentClass);
  }
}
